﻿local _, englishClass = UnitClass("player")
local GetSpellInfo = GetSpellInfo

local spellNameCache = {
	--술사
	[GetSpellInfo(49284)] = "ScanEarthShiled", --대보
	[GetSpellInfo(61301)] = "ScanRiptide", --성난해일
	
	--사제
	[GetSpellInfo(48111)] = "ScanPrayerMend",	--회기
	[GetSpellInfo(48068)] = "ScanRenew", --소생
	
	--생존기
	[GetSpellInfo(47788)] = "ScanLifeGuard", -- 수호
	[GetSpellInfo(22812)] = "ScanLifeGuard", --뿌리
	[GetSpellInfo(61336)] = "ScanLifeGuard",--생본
	[GetSpellInfo(871)] = "ScanLifeGuard", --방벽
	[GetSpellInfo(498)] = "ScanLifeGuard", --신이 가호
	[GetSpellInfo(33206)] = "ScanLifeGuard", --고통 억제
	[GetSpellInfo(47585)] = "ScanLifeGuard", --분산
	[GetSpellInfo(6940)] = "ScanLifeGuard", --희손
	[GetSpellInfo(48792)] = "ScanLifeGuard", --얼인
	[GetSpellInfo(45438)] = "ScanLifeGuard", -- 얼방
	
	--감소
	[GetSpellInfo(15359)] = "ScanReducer", --신계
	[GetSpellInfo(16237)] = "ScanReducer", --선인
	--봉화
	--[GetSpellInfo(53563)] = "ScanOfBeacon", -- 빛봉
}

local guardShortNames = {
	[GetSpellInfo(47788)] = "수호", -- 수호
	[GetSpellInfo(22812)] = "껍질", --뿌리
	[GetSpellInfo(61336)] = "생본",--생본
	[GetSpellInfo(871)] = "방벽", --방벽
	[GetSpellInfo(498)] = "가호", --신이 가호
	[GetSpellInfo(33206)] = "고억", --고통 억제
	[GetSpellInfo(47585)] = "분산", --분산
	[GetSpellInfo(6940)] = "희손", --희손
	[GetSpellInfo(48792)] = "얼인", --얼인
	[GetSpellInfo(45438)] = "얼방", -- 얼방
}

local memberCache = {}

GridStatusHealingBuff = GridStatus:NewModule("GridStatusHealingBuff")
GridStatusHealingBuff.menuName = "힐링 버프";

GridStatusHealingBuff.defaultDB = {
	debug = false,	
	frequency = 0.5,
	
	alert_eShield = {
		text = "버프: 대지의 보호막",
		desc = "버프: 대지의 보호막",
		enable = true,		
		priority = 99,
		range = false,
		color = {r=1,g=1,b=1,a=1},
	},	
	alert_rTide = {
		text = "버프: 나의 성난 해일",
		desc = "버프: 나의 성난 해일",
		enable = true,
		priority = 99,
		range = false,
		color = {r=1,g=1,b=1,a=1},
	},		
	alert_renew = {
		text = "버프: 나의 소생",
		desc = "버프: 나의 소생",
		enable = true,
		priority = 99,
		range = false,
		color = {r=1,g=1,b=1,a=1},
	},
	alert_prayerMend = {
		text = "버프: 나의 회기",
		desc = "버프: 나의 회기",
		enable = true,
		priority = 99,
		range = false,
		color = {r=1,g=1,b=1,a=1},
	},	
	alert_lifeGuard = {
		text = "버프: 생존기",
		desc = "버프: 생존기",
		enable = true,
		priority = 99,
		range = false,
		color = {r=1,g=1,b=1,a=1},
	},
	alert_reducer = {
		text = "힐링버프: 피해감소",
		desc = "힐링버프: 피해감소",
		enable = true,
		priority = 99,
		range = false,
		color = {r=1,g=1,b=1,a=1},
	},
}

GridStatusHealingBuff.extraOptions = {
	["frequency"] = {
		type = 'range',
		name = "재확인 빈도",
		desc = "버프 확인의 시간의 주기를 설정합니다.",
		get = function() return GridStatusHealingBuff.db.profile.frequency end,
		set = function(v)
				  GridStatusHealingBuff.db.profile.frequency = v
				  GridStatusHealingBuff:UpdateFrequency()
			  end,
		min = 0.01,
		max = 1,
		step = 0.01,
		isPercent = false,
		order = -1,
	},
}

function GridStatusHealingBuff:OnInitialize()
	self.super.OnInitialize(self)
	
	self:RegisterStatus("alert_lifeGuard", "힐링버프: 생존기")	
	if englishClass == "PRIEST" then		
		self:RegisterStatus("alert_renew", "힐링버프: 나의 소생")
		self:RegisterStatus("alert_prayerMend", "힐링버프: 나의 회기")
		self:RegisterStatus("alert_reducer", "힐링버프: 피해감소")
	elseif englishClass == "SHAMAN" then
		self:RegisterStatus("alert_rTide", "힐링버프: 나의 성난 해일")
		self:RegisterStatus("alert_eShield", "힐링버프: 대지의 보호막")
		self:RegisterStatus("alert_reducer", "힐링버프: 피해감소")
	end
end

function GridStatusHealingBuff:OnEnable()	
	self:RegisterEvent("UNIT_AURA","ScanUnit")	
	self:ScheduleRepeatingEvent("GHS_Refresh", self.ScanAllUnit, self.db.profile.frequency, self)
end

function GridStatusHealingBuff:UpdateFrequency()	
	self:CancelScheduledEvent("GHS_Refresh")	
	self:ScheduleRepeatingEvent("GHS_Refresh", self.ScanAllUnit, self.db.profile.frequency, self)
end

function GridStatusHealingBuff:Reset()
	self.super.Reset(self)
	
	self:UnRegisterEvent("UNIT_AURA","ScanUnit")	
	self:RegisterEvent("UNIT_AURA","ScanUnit")	
end

function GridStatusHealingBuff:ScanAllUnit()
	if memberCache then
		for i,k in pairs(memberCache) do						
			self:ScanUnit(GridRoster:GetUnitidByGUID(i))
		end
	end
end

function GridStatusHealingBuff:ScanUnit(unitid)
	local seenTable
	
	if not unitid then return end	
	
	local guid = UnitGUID(unitid)
	
	local name, rank, icon, count, debuffType, duration, expirationTime, caster, isStealable		
	local index = 1
	while true do
		name, rank, icon, count, debuffType, duration, expirationTime, caster, isStealable = UnitAura(unitid, index, "helpful")
		
		if not name then 
			break 
		end		
		
		if spellNameCache[name] then	
			if not seenTable then seenTable = {} end
			memberCache[guid] = true
			local m
			if guardShortNames[name] then m = guardShortNames[name] end
			seenTable[spellNameCache[name]] = seenTable[spellNameCache[name]] or self[spellNameCache[name]](self, guid, count, expirationTime, caster == "player", m)
		end
				
		index = index + 1
	end	
	
	if not seenTable then		
		self.core:SendStatusLost(guid, "alert_eShield")
		self.core:SendStatusLost(guid, "alert_rTide")
		self.core:SendStatusLost(guid, "alert_prayerMend")
		self.core:SendStatusLost(guid, "alert_renew")
		self.core:SendStatusLost(guid, "alert_lifeGuard")		
		self.core:SendStatusLost(guid, "alert_reducer")		
		memberCache[guid] = nil
	else		
		if not seenTable["ScanEarthShiled"] then self.core:SendStatusLost(guid, "alert_eShield") end
		if not seenTable["ScanRiptide"] then self.core:SendStatusLost(guid, "alert_rTide") end
		if not seenTable["ScanPrayerMend"] then self.core:SendStatusLost(guid, "alert_prayerMend") end
		if not seenTable["ScanRenew"] then self.core:SendStatusLost(guid, "alert_renew") end
		if not seenTable["ScanLifeGuard"] then self.core:SendStatusLost(guid, "alert_lifeGuard") end				
		if not seenTable["ScanReducer"] then self.core:SendStatusLost(guid, "alert_reducer") end				
	end
end

function GridStatusHealingBuff:ScanEarthShiled(guid, count)
	local settings = self.db.profile["alert_eShield"]		
	
	if settings.enable and englishClass == "SHAMAN" then
		local color
		local alpha = 0.125 * count
		color = {r=1.0,g=1.0,b=0.0,a=alpha}
		self.core:SendStatusGained(guid, "alert_eShield", settings.priority, (settings.range and 40), color)
		return true
	end	
	return false	
end

function GridStatusHealingBuff:ScanRiptide(guid, count, expirationTime, isMine)	
	if not isMine then
		return false
	end
	
	local settings = self.db.profile["alert_rTide"]	
	
	if settings.enable then
		local remainTime = expirationTime - GetTime()
	
		local color
		if remainTime > 5.5 then 
			color = {r = 0.0, g = 1.0, b = 0.0, a = 1.0}		
		elseif remainTime > 1.5 then
			color = {r = 1.0, g = 1.0, b = 0.0, a = 1.0}		
		else
			color = {r = 1.0, g = 0.0, b = 0.0, a = 1.0}		
		end
		
		self.core:SendStatusGained(guid, "alert_rTide", settings.priority, (settings.range and 40), color)		
		return true
	end
	return false
end

function GridStatusHealingBuff:ScanPrayerMend(guid, count, expirationTime, isMine)
	if not isMine then
		return false
	end
	
	local settings = self.db.profile["alert_prayerMend"]	
	if settings.enable then
		local color
		local alpha = 0.2 * count
		color = {r=1,g=1,b=0,a=alpha}
		self.core:SendStatusGained(guid, "alert_prayerMend", settings.priority, (settings.range and 40), color)
		return true
	end
	return false
end

function GridStatusHealingBuff:ScanRenew(guid, count, expirationTime, isMine)
	if not isMine then
		return false
	end

	local settings = self.db.profile["alert_renew"]	
	
	if settings.enable then
		local remainTime = expirationTime - GetTime()
	
		local color
		if remainTime > 5.5 then 
			color = {r = 0.0, g = 1.0, b = 0.0, a = 1.0}		
		elseif remainTime > 1.5 then
			color = {r = 1.0, g = 1.0, b = 0.0, a = 1.0}		
		else
			color = {r = 1.0, g = 0.0, b = 0.0, a = 1.0}		
		end
	
		self.core:SendStatusGained(guid, "alert_renew", settings.priority, (settings.range and 40), color)
		return true	
	end
	return false	
end

function GridStatusHealingBuff:ScanLifeGuard(guid, count, expirationTime, isMine, msg)
	local settings = self.db.profile["alert_lifeGuard"]
	
	if settings.enable then
		local remainTime = expirationTime - GetTime()
		
		local color
		local alpha = 1 - (3 - remainTime) / 3
		if remainTime > 3 then
			color = {r = 1.0, g = 0.0, b = 0.0, a = 1.0}
		else			
			color = {r = 1.0, g = 0.0, b = 0.0, a = alpha}	
		end	
		
		local text = string.format("%s%d",msg,remainTime)
		self.core:SendStatusGained(guid, "alert_lifeGuard", settings.priority, (settings.range and 40), color, text)
		return true	
	end	
	return false
end

function GridStatusHealingBuff:ScanReducer(guid, count, expirationTime, isMine, msg)
	local settings = self.db.profile["alert_reducer"]
	
	if settings.enable then
		local remainTime = expirationTime - GetTime()
		
		local color
		local alpha = 1 - (3 - remainTime) / 3
		if remainTime > 9.5 then 
			color = {r = 1.0, g = 0.0, b = 0.0, a = 0.0}		
		elseif remainTime > 5.5 then
			color = {r = 1.0, g = 0.0, b = 0.0, a = 0.5}		
		else
			color = {r = 1.0, g = 0.0, b = 0.0, a = 1.0}		
		end
		
		self.core:SendStatusGained(guid, "alert_reducer", settings.priority, (settings.range and 40), color)
		return true	
	end	
	return false
end

function GridStatusHealingBuff:UpdateAll()	
	for guid, unitid in GridRoster:IterateRoster() do
		self:ScanUnit(unitid)
	end		
end
